{% load i18n static diesos_extras %}

<script src="{% static 'js/sortable/sortable.min.js' %}"></script>

<div class="row">
  <div class="col">
    <h2>{% translate 'stabilization measures'|capfirst %}</h2>
    {% if stabilization_measures %}
      <form id="orderingForm" method="post" action="{% url 'artefacts:save-treatment-type-ordering' artefact.id %}{% if in_place %}?in_place=True{% endif %}">
      {% csrf_token %}
      <input type="hidden" id="orderingInput" name="ordering">
      <div class="table-responsive">
        <table class="table table-hover">
          <thead class="thead-light">
          <tr>
            <th class="updateDisplay"></th>
            <th></th>
            <th>{% translate 'status'|capfirst %}</th>
            <th>{% translate 'name'|capfirst %}</th>
            <th>{% translate 'color'|capfirst %}</th>
            <th>{% translate 'duration'|capfirst %}</th>
            <th>{% translate 'description'|capfirst %}</th>
            <th></th>
          </tr>
          </thead>
          <tbody id="measures">
          {% for measure in stabilization_measures %}
            <tr data-lookup="{{ measure.treatment_type.id }}">
              <td class="updateDisplay"><i class="handle bi bi-list"></i></td>
              <td><i class="h1 {{ measure.treatment_type.icon_class }}"></i></td>
              {% if measure.status %}
                <td>{{ measure.get_status_display }}</td>
              {% else %}
                <td></td>
              {% endif %}
              <td>{{ measure.treatment_type.name }}</td>
              <td>
                <div
                  style="width:20px;height:20px;background-color:{{ measure.treatment_type.color }}; border-radius:20%;"></div>
              </td>
              <td>{{ measure.treatment_type.duration|format_duration }}</td>
              <td>{{ measure.treatment_type.description|truncatechars:50 }}</td>
              <td>
              {% if perms.delete_stabilizationmeasure %}  <!-- btn delete from the list-->
                <div class="d-flex justify-content-end">
                  <a
                    href="{% url 'artefacts:delete-treatment-type' pk=artefact.id treatment_type_id=measure.treatment_type.id %}{% if in_place %}?in_place=True{% endif %}"
                    class="btn-sm btn-outline-danger mx-1"><i class="bi bi-trash"></i></a>
                </div>
              {% endif %}
              </td>
            </tr>
          {% endfor %}
          </tbody>
        </table>
      </div>
      {% if perms.artefacts.add_stabilizationmeasure or perms.artefacts.change_stabilizationmeasure %}
        <div class="d-flex justify-content-end">
          {% if display_add_button %}
            <a id="addButton" href="{% url "artefacts:change-stabilization-measure" artefact.id %}"
                   class="btn btn-outline-primary me-2">{% translate "add stabilization measure"|capfirst %}</a>
          {% endif %}
          <a id="reorderModeButton" class="btn btn-outline-primary" onclick="toggleReorderMode();">{% translate "change the order of treatments"|capfirst %}</a>
          <a id="cancelButton" href="{% url 'artefacts:change-stabilization-measure' artefact.id %}"
             class="btn btn-outline-secondary me-2" onclick="toggleReorderMode();" style="display:none;">
            <i class="bi-x-lg"></i> {% translate "cancel reorder"|capfirst %}
          </a>
          <button id="saveOrdering" class="btn btn-outline-primary" style="display:none;">{% translate "save reorder"|capfirst %}</button>
        </div>
      {% endif %}
      </form>
    {% else %}
      <p>{% translate "no stabilization measures have been defined for this artifact."|capfirst %}</p>
      {% if perms.artefacts.add_stabilizationmeasure or perms.artefacts.change_stabilizationmeasure %}
        <div class="d-flex justify-content-end">
          <a href="{% url "artefacts:change-stabilization-measure" artefact.id %}"
                 class="btn btn-outline-primary">{% translate "add stabilization measure"|capfirst %}</a>
        </div>
      {% endif %}
    {% endif %}
  </div>
</div>

<script>
  <!-- ReorderModeScript-->
  let reorder_mode = false;

  function toggleReorderMode() {
    reorder_mode = !reorder_mode;
    updateDisplay();
  }

  function updateDisplay() {
    {% if display_add_button %}
      document.getElementById('addButton').style.display = reorder_mode ? 'none' : 'inline-block';
    {% endif %}
    document.getElementById('reorderModeButton').style.display = reorder_mode ? 'none' : 'inline-block';
    document.getElementById('cancelButton').style.display = reorder_mode ? 'inline-block' : 'none';
    document.getElementById('saveOrdering').style.display = reorder_mode ? 'inline-block' : 'none';

    const hiddenStuff = document.querySelectorAll('.updateDisplay');
    for (let hidden of hiddenStuff) {
      if (reorder_mode) {
        hidden.style.display = '';
      } else {
        hidden.style.display = 'none';
      }
    }
  }

  document.addEventListener('DOMContentLoaded', () => {
    updateDisplay();
  });

  <!--DragAndDropScript-->
  const types = document.getElementById("measures");
  const saveOrderingButton = document.getElementById('saveOrdering');
  const orderingForm = document.getElementById('orderingForm');
  const formInput = orderingForm.querySelector('#orderingInput');

  let sortable = Sortable.create(types, {
    handle: '.handle',
    dragClass: 'dragged',
    chosenClass: 'sortableChosen',
  });

  function saveOrdering() {
    const rows = document.getElementById("measures").querySelectorAll('tr');
    let ids = [];
    for (let row of rows) {
      ids.push(row.dataset.lookup);
    }
    formInput.value = ids.join(',')
    console.log(ids.join(','));
    console.log(formInput.value)
    orderingForm.submit();
  }

  saveOrderingButton.addEventListener('click', function () {
    console.log('Button clicked');
    saveOrdering();
  });

</script>
